Subject: Re: [PATCH] gnu: Add guix-send-email.

From: Efraim Flashner <[email-masked]>
Date: Wed, 21 Sep 2022 13:02:50 +0300

On Tue, Sep 20, 2022 at 06:51:55PM +0200, Liliana Marie Prikler wrote:
> Am Dienstag, dem 20.09.2022 um 13:00 +0300 schrieb Efraim Flashner:
> > * gnu/packages/guix-extensions.scm (guix-send-email): New variable.
> > * gnu/local.mk (GNU_SYSTEM_MODULES): Add guix-extensions.
> Probably unnecessary file; gwl lives nice in package-management.

I'm expecting that there will be other ones eventually, and I didn't
really think it fit with package-management.

> > ---
> >  gnu/local.mk                     |  1 +
> >  gnu/packages/guix-extensions.scm | 62
> > ++++++++++++++++++++++++++++++++
> >  2 files changed, 63 insertions(+)
> >  create mode 100644 gnu/packages/guix-extensions.scm
> > 
> > diff --git a/gnu/local.mk b/gnu/local.mk
> > index 238fb72bc5..ba28788776 100644
> > --- a/gnu/local.mk
> > +++ b/gnu/local.mk
> > @@ -295,6 +295,7 @@ GNU_SYSTEM_MODULES
> > =                                \
> >    %D%/packages/guile.scm                       \
> >    %D%/packages/guile-wm.scm                    \
> >    %D%/packages/guile-xyz.scm                   \
> > +  %D%/packages/guix-extensions.scm             \
> >    %D%/packages/gv.scm                          \
> >    %D%/packages/gxmessage.scm                   \
> >    %D%/packages/hardware.scm                    \
> > diff --git a/gnu/packages/guix-extensions.scm b/gnu/packages/guix-
> > extensions.scm
> > new file mode 100644
> > index 0000000000..bb23b59de4
> > --- /dev/null
> > +++ b/gnu/packages/guix-extensions.scm
> > @@ -0,0 +1,62 @@
> > +;;; Copyright © 2022 Efraim Flashner <[email-masked]>
> > +;;;
> > +;;; GNU Guix is free software; you can redistribute it and/or modify
> > it
> > +;;; under the terms of the GNU General Public License as published
> > by
> > +;;; the Free Software Foundation; either version 3 of the License,
> > or (at
> > +;;; your option) any later version.
> > +;;;
> > +;;; GNU Guix is distributed in the hope that it will be useful, but
> > +;;; WITHOUT ANY WARRANTY; without even the implied warranty of
> > +;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> > +;;; GNU General Public License for more details.
> > +;;;
> > +;;; You should have received a copy of the GNU General Public
> > License
> > +;;; along with GNU Guix.  If not, see
> > <http://www.gnu.org/licenses/>.
> > +
> > +(define-module (gnu packages guix-extensions)
> > +  #:use-module ((guix licenses) #:prefix license:)
> > +  #:use-module (guix gexp)
> > +  #:use-module (guix packages)
> > +  #:use-module (guix build-system trivial)
> > +  #:use-module (gnu packages version-control))
> > +
> > +(define-public guix-send-email
> > +  (package
> > +    (name "guix-send-email")
> > +    (version "0")
> > +    (source #f)
> > +    (build-system trivial-build-system)
> > +    (arguments
> > +     (list
> > +       #:modules '((guix build utils))
> > +       #:builder
> > +       #~(begin
> > +           (use-modules (guix build utils))
> > +           (let ((dest (string-append #$output
> > +                                      "/share/guix/extensions/send-
> > email.scm"))
> > +                 (git            #$(this-package-input "git"))
> > +                 (git-send-email (assoc-ref %build-inputs "git:send-
> > email")))
> > +             (mkdir-p (dirname dest))
> > +             (with-output-to-file dest
> > +               (lambda ()
> > +                 (format #t
> > +"(define-module (guix extensions send-email)~@
> > +                #:use-module (guix scripts)~@
> > +                #:export (guix-send-email))~@
> > +~@
> > +(define-command (guix-send-email . args)~@
> > +                (category extension)~@
> > +                (synopsis \"Replace 'guix send-email' with 'git
> > send-email'\")~@
> > +                (setenv \"GIT_EXEC_PATH\" \"~a/libexec/git-core\")~@
> > +                (apply system* \"~a/bin/git\" \"send-email\"
> > args))~%"
> > +                 git-send-email git)))))))
> > +    (home-page "")  ; Should be documentation location for
> > GUIX_EXTENSIONS_PATH
> > +    (inputs
> > +     `(("git" ,git)
> > +       ("git:send-email" ,git "send-email")))
> > +    (synopsis "Replace @code{guix send-email} with @code{git send-
> > email}")
> > +    (description "This Guix extension provides a shell redirect from
> > @code{guix
> > +send-email} to @code{git send-email}.")
> > +    ;; The package definition is longer than the code;
> > +    ;; let this serve as the declaration of the license.
> > +    (license license:gpl3+)))
> I don't think this is a useful tool to provide at all nor a useful way
> of providing it.  For one, I think users of "guix send-email" (which
> for the record should probably be guix git send-email analogous to our
> other git extensions) would like to have some features from
> etc/teams.scm incorporated into them rather than having a wrapper that
> simply performs the same operation.  For the other, the implementation
> takes up more place in Guix than defining the actual command internally
> would.  Thus, I doubt whether the design choices made here were wise
> ones.

I suppose I didn't explain the package well in the description, but the
purpose was to (a) create a simple guix extension to serve as an example
for other people, and (b) to "solve" the case of "oops, I wrote guix
send-email instead of git send-email".

It's also not an extension that I personally would see myself
installing.

I would be happy to change it into a cookbook entry, starting with
(display "Hello World"), moving to (apply system* %hello/bin/hello args)
and finally guix-send-email to add an example with needing a bit more
complexity but still understandable. Or guix-vacuum-database, to wrap
vacuuming /var/guix/db/db.sqlite in a guix extension.

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted